var _ = require('lodash');
var Task = (function () {
    function Task(props) {
        this.name = props.name;
        this.deps = (props.deps && [].concat(_.cloneDeep(props.deps))) || [];
        this.config = _.cloneDeep(props.config);
        var executionContext = _.cloneDeep(this);
        /* eslint-disable no-unused-vars */
        this.action = props.action ? function (callback) {
            /* eslint-enable no-unused-vars */
            var args = Array.prototype.slice.call(arguments);
            return props.action.apply(_.cloneDeep(executionContext), args);
        } : null;
        Task.REGISTER[props.name] = this;
    }
    Task.get = function (name) {
        return Task.REGISTER[name];
    };
    Task.REGISTER = {};
    return Task;
})();
exports.Task = Task;
